using System;
using System.ComponentModel;
using System.Web.UI;
using System.IO;
using System.Reflection;

namespace MyWebControls
{
    [DefaultProperty("Text")]
    [ToolboxData("<{0}:TADropDown runat=server></{0}:TADropDown>")]
    public class TADropDown : System.Web.UI.WebControls.DropDownList
    {
        const string js = "TADDScript.js";

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);

            // Write and include the script file.
            Type typ = this.GetType();
            if (!Page.ClientScript.IsClientScriptIncludeRegistered(typ, js))
            {
                Page.ClientScript.RegisterClientScriptInclude(typ, js, js);

                if (!File.Exists(Page.Request.PhysicalApplicationPath + js))
                {
                    // Read and write the javascript file to the server's disk
                    Stream rs =
                      Assembly.GetExecutingAssembly().GetManifestResourceStream(
                        "WebControlLibraries." + js);
                    StreamReader sr = new StreamReader(rs);
                    StreamWriter sw =
                        File.CreateText(Page.Request.PhysicalApplicationPath + js);

                    sw.Write(sr.Read());
                    rs.Close(); sr.Close(); sw.Close();
                }
            }

            // Add the OnKeyDown attribute to all drop downs.  This 
            // ensures that keystrokes will be captured and selected.
            Attributes.Add("onKeyDown", "TADD_OnKeyDown(this);");
        }
    }
}
